(*  Title:      HOL/Auth/ROOT
    ID:         $Id: ROOT.ML,v 1.27 2005/09/14 21:14:57 wenzelm Exp $
    Author:     Lawrence C Paulson, Cambridge University Computer Laboratory
    Copyright   1996  University of Cambridge

Root file for protocol proofs.
*)

no_document use_thy "NatPair";

add_path "Guard";

set timing;

(*Shared-key protocols*)
time_use_thy "NS_Shared";
time_use_thy "Kerberos_BAN";
time_use_thy "KerberosIV";
time_use_thy "OtwayRees";
time_use_thy "OtwayRees_AN";
time_use_thy "OtwayRees_Bad";
time_use_thy "WooLam";
time_use_thy "Recur";
time_use_thy "Yahalom";
time_use_thy "Yahalom2";
time_use_thy "Yahalom_Bad";
time_use_thy "ZhouGollmann";

(*Public-key protocols*)
time_use_thy "NS_Public_Bad";
time_use_thy "NS_Public";
time_use_thy "TLS";
time_use_thy "CertifiedEmail";

(*Blanqui's "guard" concept: protocol-independent secrecy*)
time_use_thy "P1";
time_use_thy "P2";
time_use_thy "Guard_NS_Public";
time_use_thy "Guard_OtwayRees";
time_use_thy "Guard_Yahalom";
time_use_thy "Proto";
